/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.34 Revision 1.53
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.34 2006/09/20 08:23:41 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.53 2008/02/13 19:44:44 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
38# 38#
39# If ${VDR_RCADDON_FILE} is set install this file 39# If ${VDR_RCADDON_FILE} is set install this file
40# else install ${FILESDIR}/rc-addon.sh if it exists. 40# else install ${FILESDIR}/rc-addon.sh if it exists.
41# 41#
42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh 42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh) 43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
44# 44#
45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr 45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46# It could be used for special startup actions for this plugins, or to create the 46# It could be used for special startup actions for this plugins, or to create the
47# plugin command line options from a nicer version of a conf.d file. 47# plugin command line options from a nicer version of a conf.d file.
48 48
58# all patches which ending on diff or patch in this DIR will automatically applied 58# all patches which ending on diff or patch in this DIR will automatically applied
59# 59#
60 60
61inherit base multilib eutils flag-o-matic 61inherit base multilib eutils flag-o-matic
62 62
63IUSE="debug" 63IUSE=""
64 64
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 66VDRPLUGIN="${PN/#vdrplugin-/}"
67VDRPLUGIN="${VDRPLUGIN/#vdr-/}" 67VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
68VDRPLUGIN="${VDRPLUGIN/%-cvs/}" 68VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 )
78 >=app-admin/eselect-vdr-0.0.2
77DEPEND="media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
78 80
79 81
80# this code is from linux-mod.eclass 82# New method of storing plugindb
81update_vdrplugindb() { 83# Called from src_install
84# file maintained by normal portage-methods
85create_plugindb_file() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 86 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
87 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
88 insinto "${NEW_VDRPLUGINDB_DIR}"
83 89
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then 90# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR} 91# cat <<-EOT > "${D}/${DB_FILE}"
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb 92# VDRPLUGIN_DB=1
93# CREATOR=ECLASS
94# EBUILD=${CATEGORY}/${PN}
95# EBUILD_V=${PVR}
96# EOT
97 {
98 echo "VDRPLUGIN_DB=1"
99 echo "CREATOR=ECLASS"
100 echo "EBUILD=${CATEGORY}/${PN}"
101 echo "EBUILD_V=${PVR}"
102 } > "${D}/${DB_FILE}"
103}
104
105# Delete files created outside of vdr-plugin.eclass
106# vdrplugin-rebuild.ebuild converted plugindb and files are
107# not deleted by portage itself - should only be needed as
108# long as not every system has switched over to
109# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
110delete_orphan_plugindb_file() {
111 #elog Testing for orphaned plugindb file
112 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
113 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
114
115 # file exists
116 [[ -f ${DB_FILE} ]] || return
117
118 # will portage handle the file itself
119 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
120 #elog file owned by eclass - don't touch it
121 return
122 fi
123
124 elog "Removing orphaned plugindb-file."
125 elog "\t#rm ${DB_FILE}"
126 rm "${DB_FILE}"
127}
128
129
130create_header_checksum_file()
131{
132 # Danger: Not using $ROOT here, as compile will also not use it !!!
133 # If vdr in $ROOT and / differ, plugins will not run anyway
134
135 insinto "${VDR_CHECKSUM_DIR}"
136 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
137 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}"
138 else
139 if type -p md5sum >/dev/null 2>&1; then
140 cd "${S}"
141 (
142 cd "${VDR_INCLUDE_DIR}"
143 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
144 ) > header-md5-${PN}
145 doins header-md5-${PN}
87 fi 146 fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi 147 fi
101} 148}
102 149
103vdr-plugin_pkg_setup() { 150vdr-plugin_pkg_setup() {
104 # -fPIC is needed for shared objects on some platforms (amd64 and others) 151 # -fPIC is needed for shared objects on some platforms (amd64 and others)
105 append-flags -fPIC 152 append-flags -fPIC
106 use debug && append-flags -g
107 153
108 # Where should the plugins live in the filesystem 154 # Where should the plugins live in the filesystem
109 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 155 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
110 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 156 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
111 157
112 # transition to /usr/share/... will need new vdr-scripts version stable 158 # was /usr/lib/... some time ago
159 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
113 VDR_RC_DIR="/usr/lib/vdr/rcscript" 160 VDR_RC_DIR="/usr/share/vdr/rcscript"
114 161
115 # Pathes to includes 162 # Pathes to includes
116 VDR_INCLUDE_DIR="/usr/include/vdr" 163 VDR_INCLUDE_DIR="/usr/include/vdr"
117 DVB_INCLUDE_DIR="/usr/include" 164 DVB_INCLUDE_DIR="/usr/include"
118 165
119 166
167 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
168 LOCDIR="/usr/share/vdr/locale"
169 if has_version ">=media-video/vdr-1.5.7"; then
170 USE_GETTEXT=1
171 else
172 USE_GETTEXT=0
173 fi
174
120 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 175 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
121 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 176 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
122 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 177 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
123 178
124 einfo "Building ${PF} against vdr-${VDRVERSION}" 179 einfo "Building ${PF} against vdr-${VDRVERSION}"
125 einfo "APIVERSION: ${APIVERSION}" 180 einfo "APIVERSION: ${APIVERSION}"
126} 181}
131 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 186 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
132 echo 187 echo
133 eerror "Please report this at bugs.gentoo.org." 188 eerror "Please report this at bugs.gentoo.org."
134 die "vdr-plugin_pkg_setup not called!" 189 die "vdr-plugin_pkg_setup not called!"
135 fi 190 fi
136 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile 191 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n
137 192
138 while [ "$1" ]; do 193 while [ "$1" ]; do
139 194
140 case "$1" in 195 case "$1" in
141 all_but_unpack) 196 all_but_unpack)
142 vdr-plugin_src_unpack add_local_patch patchmakefile 197 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
143 ;; 198 ;;
144 unpack) 199 unpack)
145 base_src_unpack 200 base_src_unpack
146 ;; 201 ;;
147 patchmakefile) 202 patchmakefile)
148 if ! cd ${S}; then 203 if ! cd "${S}"; then
149 ewarn "There seems to be no plugin-directory with the name ${S##*/}" 204 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
150 ewarn "Perhaps you find one among these:" 205 ewarn "Perhaps you find one among these:"
151 cd "${WORKDIR}" 206 cd "${WORKDIR}"
152 einfo "$(/bin/ls -1 ${WORKDIR})" 207 ewarn "$(/bin/ls -1 "${WORKDIR}")"
153 die "Could not change to plugin-source-directory!" 208 die "Could not change to plugin-source-directory!"
154 fi 209 fi
155 210
156 einfo "Patching Makefile" 211 einfo "Patching Makefile"
157 [[ -e Makefile ]] || die "Makefile of plugin can not be found!" 212 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
158 cp Makefile Makefile.orig 213 cp Makefile "${WORKDIR}"/Makefile.before
159 214
160 sed -i Makefile \ 215 sed -i Makefile \
161 -e '1i\#Makefile was patched by vdr-plugin.eclass' 216 -e '1i\#Makefile was patched by vdr-plugin.eclass'
162 217
163 ebegin " Setting Pathes" 218 ebegin " Setting Pathes"
176 -e 's:^APIVERSION = :APIVERSION ?= :' \ 231 -e 's:^APIVERSION = :APIVERSION ?= :' \
177 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \ 232 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
178 -e '2i\APIVERSION = '"${APIVERSION}" 233 -e '2i\APIVERSION = '"${APIVERSION}"
179 eend $? 234 eend $?
180 235
181 ebegin " Correcting CXXFLAGS" 236 ebegin " Correcting Compile-Flags"
182 sed -i Makefile \ 237 sed -i Makefile \
183 -e 's:^CXXFLAGS:#CXXFLAGS:' 238 -e 's:^CXXFLAGS:#CXXFLAGS:' \
239 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
184 eend $? 240 eend $?
185 241
186 ebegin " Disabling file stripping" 242 ebegin " Disabling file stripping"
187 sed -i Makefile \ 243 sed -i Makefile \
188 -e '/@.*strip/d' \ 244 -e '/@.*strip/d' \
191 -e '/@.*\$(STRIP)/d' 247 -e '/@.*\$(STRIP)/d'
192 eend $? 248 eend $?
193 249
194 # Use a file instead of an variable as single-stepping via ebuild 250 # Use a file instead of an variable as single-stepping via ebuild
195 # destroys environment. 251 # destroys environment.
196 touch ${WORKDIR}/.vdr-plugin_makefile_patched 252 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
197 ;; 253 ;;
198 add_local_patch) 254 add_local_patch)
199 cd ${S} 255 cd "${S}"
200 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then 256 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
201 echo 257 echo
202 einfo "Applying local patches" 258 einfo "Applying local patches"
203 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do 259 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
204 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}" 260 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
205 done 261 done
206 fi 262 fi
207 ;; 263 ;;
264 i18n)
265 cd "${S}"
266 if [[ ${USE_GETTEXT} = 0 ]]; then
267 # Remove i18n Target if using older vdr
268 sed -i Makefile \
269 -e '/^all:/s/ i18n//'
270 elif [[ ${USE_GETTEXT} = 1 && ! -d po && ${NO_GETTEXT_HACK} != 1 ]]; then
271 einfo "Converting translations to gettext"
272
273 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
274 if [[ ! -x ${i18n_tool} ]]; then
275 eerror "Missing ${i18n_tool}"
276 eerror "Please re-emerge vdr"
277 die "Missing ${i18n_tool}"
278 fi
279
280 # call i18n-to-gettext tool
281 # take all texts missing tr call into special file
282 "${i18n_tool}" 2>/dev/null \
283 |sed -e '/^"/!d' \
284 -e '/^""$/d' \
285 -e 's/\(.*\)/trNOOP(\1)/' \
286 > dummy-translations-trNOOP.c
287
288 # if there were untranslated texts just run it again
289 # now the missing calls are listed in
290 # dummy-translations-trNOOP.c
291 if [[ -s dummy-translations-trNOOP.c ]]; then
292 "${i18n_tool}" &>/dev/null
293 fi
294
295 # now use the modified Makefile
296 mv Makefile.new Makefile
297 fi
208 esac 298 esac
209 299
210 shift 300 shift
211 done 301 done
212} 302}
213 303
214vdr-plugin_copy_source_tree() { 304vdr-plugin_copy_source_tree() {
215 pushd . >/dev/null 305 pushd . >/dev/null
216 cp -r ${S} ${T}/source-tree 306 cp -r "${S}" "${T}"/source-tree
217 cd ${T}/source-tree 307 cd "${T}"/source-tree
218 mv Makefile.orig Makefile 308 cp "${WORKDIR}"/Makefile.before Makefile
219 sed -i Makefile \ 309 sed -i Makefile \
220 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 310 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
221 -e 's:^CXXFLAGS:#CXXFLAGS:' \ 311 -e 's:^CXXFLAGS:#CXXFLAGS:' \
222 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \ 312 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
223 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' 313 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
224 popd >/dev/null 314 popd >/dev/null
225} 315}
226 316
227vdr-plugin_install_source_tree() { 317vdr-plugin_install_source_tree() {
228 einfo "Installing sources" 318 einfo "Installing sources"
229 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN} 319 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
230 insinto ${destdir}-${PV} 320 insinto "${destdir}-${PV}"
231 doins -r ${T}/source-tree/* 321 doins -r "${T}"/source-tree/*
232 322
233 dosym ${VDRPLUGIN}-${PV} ${destdir} 323 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
234} 324}
235 325
236vdr-plugin_src_compile() { 326vdr-plugin_src_compile() {
237 [ -z "$1" ] && vdr-plugin_src_compile prepare compile 327 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
238 328
249 eerror "calling vdr-plugin_src_unpack to patch the Makefile." 339 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
250 echo 340 echo
251 eerror "Please report this at bugs.gentoo.org." 341 eerror "Please report this at bugs.gentoo.org."
252 die "vdr-plugin_src_unpack not called!" 342 die "vdr-plugin_src_unpack not called!"
253 fi 343 fi
254 cd ${S} 344 cd "${S}"
255 345
256 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed" 346 emake ${BUILD_PARAMS} \
347 ${VDRPLUGIN_MAKE_TARGET:-all} \
348 LOCALEDIR="${TMP_LOCALE_DIR}" \
349 || die "emake failed"
257 ;; 350 ;;
258 esac 351 esac
259 352
260 shift 353 shift
261 done 354 done
262} 355}
263 356
264vdr-plugin_src_install() { 357vdr-plugin_src_install() {
265 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 358 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
266 cd ${S} 359 cd "${WORKDIR}"
267 360
268 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then 361 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
269 local mname=${P}-Makefile 362 local mname="${P}-Makefile"
270 cp Makefile ${mname}.patched 363 cp "${S}"/Makefile "${mname}.patched"
271 cp Makefile.orig ${mname}.before 364 cp Makefile.before "${mname}.before"
272 365
273 diff -u ${mname}.before ${mname}.patched > ${mname}.diff 366 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
274 367
275 insinto "/usr/share/vdr/maintainer-data/makefile-changes" 368 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
276 doins ${mname}.diff 369 doins "${mname}.diff"
277 370
278 insinto "/usr/share/vdr/maintainer-data/makefile-before" 371 insinto "/usr/share/vdr/maintainer-data/makefile-before"
279 doins ${mname}.before 372 doins "${mname}.before"
280 373
281 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 374 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
282 doins ${mname}.patched 375 doins "${mname}.patched"
283 376
284 fi 377 fi
285 378
379 cd "${S}"
286 insinto "${VDR_PLUGIN_DIR}" 380 insinto "${VDR_PLUGIN_DIR}"
287 doins libvdr-*.so.* 381 doins libvdr-*.so.*
382
383 if [[ ${USE_GETTEXT} = 1 && -d ${TMP_LOCALE_DIR} ]]; then
384 einfo "Installing locales"
385 cd "${TMP_LOCALE_DIR}"
386 insinto "${LOCDIR}"
387 doins -r *
388 fi
389
390 cd "${S}"
288 local docfile 391 local docfile
289 for docfile in README* HISTORY CHANGELOG; do 392 for docfile in README* HISTORY CHANGELOG; do
290 [[ -f ${docfile} ]] && dodoc ${docfile} 393 [[ -f ${docfile} ]] && dodoc ${docfile}
291 done 394 done
292 395
293 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it 396 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
294 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd 397 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
295 398
296 if [[ -n ${VDR_CONFD_FILE} ]]; then 399 if [[ -n ${VDR_CONFD_FILE} ]]; then
297 insinto /etc/conf.d
298 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN} 400 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
299 fi 401 fi
300 402
301 403
302 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it 404 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
303 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh 405 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
305 if [[ -n ${VDR_RCADDON_FILE} ]]; then 407 if [[ -n ${VDR_RCADDON_FILE} ]]; then
306 insinto "${VDR_RC_DIR}" 408 insinto "${VDR_RC_DIR}"
307 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 409 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
308 fi 410 fi
309 411
412 create_header_checksum_file
413 create_plugindb_file
414}
310 415
311 416vdr-plugin_print_enable_command() {
312 insinto ${VDR_CHECKSUM_DIR} 417 ewarn "emerge --config ${PN} is deprecated"
313 if [[ -f ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 418 elog
314 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 419 elog "To activate this vdr-plugin execute the following command:"
315 else 420 elog "\teselect vdr-plugin enable ${PN#vdr-}"
316 if which md5sum >/dev/null 2>&1; then 421 elog
317 cd ${S}
318 (
319 cd ${ROOT}${VDR_INCLUDE_DIR}
320 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
321 ) > header-md5-${PN}
322 doins header-md5-${PN}
323 fi
324 fi
325} 422}
326 423
327vdr-plugin_pkg_postinst() { 424vdr-plugin_pkg_postinst() {
328 update_vdrplugindb 425 vdr-plugin_print_enable_command
329 einfo 426
330 einfo "The vdr plugin ${VDRPLUGIN} has now been installed."
331 einfo "To activate execute the following command:"
332 einfo
333 einfo " emerge --config ${PN}"
334 einfo
335 if [[ -n "${VDR_CONFD_FILE}" ]]; then 427 if [[ -n "${VDR_CONFD_FILE}" ]]; then
336 einfo "And have a look at the config-file" 428 elog "Please have a look at the config-file"
337 einfo "/etc/conf.d/vdr.${VDRPLUGIN}" 429 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
338 einfo 430 elog
339 fi 431 fi
340} 432}
341 433
342vdr-plugin_pkg_postrm() { 434vdr-plugin_pkg_postrm() {
343 remove_vdrplugindb 435 delete_orphan_plugindb_file
344} 436}
345 437
346vdr-plugin_pkg_config_final() {
347 diff ${conf_orig} ${conf}
348 rm ${conf_orig}
349}
350
351vdr-plugin_pkg_config() { 438vdr-plugin_pkg_config_legacy() {
439 elog "Using old interface to gentoo-vdr-scripts-0.3.7"
352 if [[ -z "${INSTALLPLUGIN}" ]]; then 440 if [[ -z "${INSTALLPLUGIN}" ]]; then
353 INSTALLPLUGIN="${VDRPLUGIN}" 441 INSTALLPLUGIN="${VDRPLUGIN}"
354 fi 442 fi
443
444 active=0
355 # First test if plugin is already inside PLUGINS 445 # First test if plugin is already inside PLUGINS
356 local conf=/etc/conf.d/vdr 446 local conf=/etc/conf.d/vdr.plugins
357 conf_orig=${conf}.before_emerge_config 447 exec 3<${conf}
358 cp ${conf} ${conf_orig} 448 while read -u 3 line; do
359 449 [[ ${line} == "" ]] && continue
360 einfo "Reading ${conf}" 450 [[ ${line:0:1} == "#" ]] && continue
361 if ! grep -q "^PLUGINS=" ${conf}; then 451 set -- ${line}
362 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1) 452 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
363 if [[ -n "${LINE}" ]]; then
364 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
365 else
366 echo 'PLUGINS=""' >> ${conf}
367 fi
368 unset LINE
369 fi
370
371 unset PLUGINS
372 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
373
374 active=0
375 for p in ${PLUGINS}; do
376 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
377 active=1
378 break;
379 fi
380 done 453 done
454 exec 3<&-
381 455
382 if [[ "${active}" == "1" ]]; then 456 if [[ $active == 0 ]]; then
457 elog "Adding ${INSTALLPLUGIN} to active plugins."
458
459 # The pure edit process.
460 echo "${INSTALLPLUGIN}" >> "${conf}"
461 else
383 einfo "${INSTALLPLUGIN} already activated" 462 elog "${INSTALLPLUGIN} already activated"
384 echo 463 echo
385 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer 464 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
386 if [[ "${answer}" != "yes" ]]; then 465 if [[ "${answer}" != "yes" ]]; then
387 einfo "aborted" 466 elog "aborted"
388 return 467 return
389 fi 468 fi
390 einfo "Removing ${INSTALLPLUGIN} from active plugins." 469 elog "Removing ${INSTALLPLUGIN} from active plugins."
391 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
392 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
393 -e ${LINE}'s/ \( \)*/ /g' \
394 -e ${LINE}'s/ "/"/g' \
395 -e ${LINE}'s/" /"/g'
396 470
397 vdr-plugin_pkg_config_final 471 # The pure edit process
398 return 472 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
399 fi 473 fi
474}
400 475
401
402 einfo "Adding ${INSTALLPLUGIN} to active plugins."
403 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
404 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
405 -e ${LINE}'s/ \( \)*/ /g' \
406 -e ${LINE}'s/ "/"/g' \
407 -e ${LINE}'s/" /"/g'
408
409 vdr-plugin_pkg_config_final 476vdr-plugin_pkg_config() {
477 vdr-plugin_print_enable_command
478
479 einfo "Calling this now"
480 eselect vdr-plugin enable "${PN#vdr-}"
410} 481}
411 482
412fix_vdr_libsi_include() 483fix_vdr_libsi_include()
413{ 484{
414 einfo "Fixing include of libsi-headers" 485 einfo "Fixing include of libsi-headers"

Legend:
Removed from v.1.34  
changed lines
  Added in v.1.53

  ViewVC Help
Powered by ViewVC 1.1.20